/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_NUTRICIO                                                 */
/* Tabela : NUTRICIO                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 28/10/2004 - Rafael dos Santos Lopes                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_NUTRICIO
BEFORE INSERT OR UPDATE OR DELETE
ON NUTRICIO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUNCIO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NRCRNNUTRICI,0) <> NVL(:NEW.NRCRNNUTRICI,0)) THEN
         :NEW.DTULTATUNCIO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('NUTRICIO', '', 'CDNUTRICIO='||:OLD.CDNUTRICIO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE NUTRICIO MODIFY DTULTATUNCIO DEFAULT SYSDATE
/


-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_NUTRICIO','4.05.052'); END;
/

